package sugui;

import static org.junit.Assert.assertEquals;

import java.io.IOException;
import java.util.List;

import org.junit.Test;

import sugui.day05.Day05;

/**
 * Unit test for simple App.
 */
public class Day05Test {

    public static String firstBasicInput = """
            seeds: 79 14 55 13

            seed-to-soil map:
            50 98 2
            52 50 48

            soil-to-fertilizer map:
            0 15 37
            37 52 2
            39 0 15

            fertilizer-to-water map:
            49 53 8
            0 11 42
            42 0 7
            57 7 4

            water-to-light map:
            88 18 7
            18 25 70

            light-to-temperature map:
            45 77 23
            81 45 19
            68 64 13

            temperature-to-humidity map:
            0 69 1
            1 0 69

            humidity-to-location map:
            60 56 37
            56 93 4
            """;
    public static String secondBasicInput = firstBasicInput;
    public static String firstBasicResult = "35";
    public static String secondBasicResult = "46";

    @Test
    public void firstBasicCase() throws IOException {
        String actualResult = Day05.getFirstPuzzleResult(firstBasicInput);
        assertEquals(firstBasicResult, actualResult);
    }

    @Test
    public void isGetLocationExclusive() {
        assertEquals(Day05.getLocation(List.of(
                new Day05.MapInfo(30, 0, 2)), 2),
                2);
    }

    @Test
    public void secondBasicCase() throws IOException {
        String actualResult = Day05.getSecondPuzzleResult(secondBasicInput);
        assertEquals(secondBasicResult, actualResult);
    }
}
